<template>
  <div class="filter-documentation">
    <ControlGroup
        v-model="tab"
        :items="items"
        theme="light"
        class="filter-documentation__tabs"
        @input="SET_TABS"
    />

    <component
        :is="component"
        @changeDirection="changeDirection"
        @showRole="showRole"
    />

    <ob-modal
        ref="delete-all-settings"
        size="small"
        title="Удалить все направления?"
        :is-error="true"
        :is-show-controls="true"
        ok-text="Удалить"
        cancel-text="Отменить"
        @submit="noDelete"
    >
      <div>Для клиента: {{customer}}</div>
    </ob-modal>
  </div>
</template>

<script>
  import ControlGroup from "common-components/src/obComponents/obControlGroup";
  import AllClients from "./AllClients";
  import ByCarrier from "./ByCarrier";
  import ObModal from "common-components/src/obComponents/obModal";
  import {mapGetters, mapMutations, mapActions} from "vuex";

  export default {
    name: "FilterPanel",
    components: {
      ControlGroup,
      AllClients,
      ByCarrier,
      ObModal
    },
    data() {
      return {
        items: [
          {
            label: 'Для всех заказов по умолчанию',
            value: 'ALL'
          },
          {
            label: 'Индивидуально для Клиентов',
            value: 'FOR_CLIENT'
          },
          {
            label: 'Дополнительно для Перевозчиков',
            value: 'BY_CARRIER'
          }
        ],
        role: null
      }
    },
    computed: {
      ...mapGetters({
        tab: 'clicarSettings/tab',
        list_customers: 'clicarSettings/list_customers',
        client_uuid: 'clicarSettings/client_uuid',
        answerByServer: 'clicarSettings/answerByServer',
        flag_setting_direction: 'clicarSettings/flag_setting_direction'
      }),
      customer() {
        if (this.role) {
          return this.list_customers.find(key => key.uuid === this.client_uuid).name;
        }
        return ''
      },
      component() {
        return this.tab === 'BY_CARRIER' ? ByCarrier : AllClients
      }
    },
    watch: {
      tab(type) {
        this.$emit('setDirection', 'all_directions');
        this.choiceTypeDirection(type);
      }
    },
    methods: {
      ...mapMutations({
        SET_TABS: 'clicarSettings/SET_TABS',
      }),
      ...mapActions({
        choiceTypeDirection: 'clicarSettings/choiceTypeDirection',
        deleteAllDirection: 'clicarSettings/deleteAllDirection'
      }),
      changeDirection(direction) {
        this.$emit('setDirection', direction);
      },
      showRole(role) {
        this.role = role
      },
      async noDelete() {
        await this.deleteAllDirection()
          .then(() => {
            if (this.answerByServer === 'success') {
              this.$notification({
                type: 'system_notification_success',
                message: 'Все услуги удалены'
              });
              this.$refs['delete-all-settings'].close();
            } else if (this.answerByServer === 'error') {
              this.$notification({
                type: 'system_notification_error',
                message: 'Не удается удалить услуги'
              })
            }
          })
      }
    }
  }
</script>

<style lang="scss">
  .filter-documentation {
    &__text {
      padding: 30px 0 12px;
      font-size: 16px;
      line-height: 20px;
      letter-spacing: 0.4px;
      color: $Grey-900;
    }

    &__add-group {
      display: flex;
      justify-content: space-between;
      align-items: center;
      margin-top: 20px;

      &-left {
        display: flex;

        &-select {
          width: 500px;
          margin-right: 23px;
        }
      }

      &-right {
        font-size: 14px;
        line-height: 16px;
        letter-spacing: 0.2px;
        color: $color-error;
        cursor: pointer;
      }
    }

    &__bottom {
      margin-bottom: 30px;
    }

    &__inputs {
      display: flex;
      margin-bottom: 30px;

      &-input {
        margin-right: 10px;
      }
    }

  }
</style>

<style lang="scss">
  .ob-selector__list {
    .ob-selector__list-item-title-wrapper {
      position: relative;
      width: 100%;

      .ob-selector__list-item-html {
        margin-right: 0;
        .ob-selector_gear {
          font-size: 16px;
          color: $color-grey-span;
          position: absolute;
          right: 15px;
        }
      }
    }
  }
</style>

